<template>
<div
	:class="class_name"
	v-on:click="onClick"
	v-on:mouseover="onHover"
>
	<slot />
	<input ref="textfield" type="text" :value="value" v-on:blur="onBlur" v-on:input="onType" />
</div>
</template>

<script>
export default {
	computed: {
		class_name: function () {
			if (!this.selected) this.$refs.textfield.blur()
			return {
				[this.size]: true,
				fullwidth: this.fullwidth ? true : false,
				item: true,
				selected: this.selected
			}
		},
		size: function () {
			return this.config ? this.config.size : "normal"
		}
	},
	created () {
		this.$on("PRESS_ENTER", () => {
			this.blur()
		})
	},
	data () {
		return { focused: false }
	},
	methods: {
		blur: function () {
			this.$refs.textfield.blur()
			this.focused = false
		},
		onBlur: function () {
			this.focused = false
		},
		onClick: function () {
			this.$refs.textfield.focus()
			this.focused = true
		},
		onHover: function () {
			this.$emit("hover", this.id)
		},
		onType: function () {
			const ref = this.$refs.textfield
			ref.value = ref.value.slice(0, this.limit || 12)
			this.$emit("change", this.id, ref.value)
		}
	},
	name: "input-item",
	props: [ "config", "fullwidth", "id", "limit", "selected", "value" ]
}
</script>

<style lang="less" scoped>
@import "./styles/Item.less";
.fullwidth {
	input {
		width: 100%;
	}
}

.small {
	input {
		width: 8em;
	}
}
</style>